#!/usr/bin/perl

%DRV_NAME;
%MAJOR_NUM;

$MAX_PCI_CARDS=4;

$_7841_CARDS;
$DRIVER_PATH;
$INSMOD_COMMAND;

if(  $ARGV[0] ne "" ){
   ($_7841_CARDS) = $ARGV[0] =~ /(\d+)/;
   ($pre_str, $temp_num) = $ARGV[0] =~ /(\D+)(\d+)/;
   ($temp_num, $post_str ) = $ARGV[0] =~ /(\d+)(\D+)/;
   if ( $pre_str ne "" ){
       $_7841_CARDS = "";
   }elsif ( $post_str ne "" ){ 
       $_7841_CARDS = "";
   }

   if ( $_7841_CARDS > $MAX_PCI_CARDS ){
       $_7841_CARDS = "";
   }
}else{
   $_7841_CARDS = "";
}


if(  $_7841_CARDS eq "" ){
   print("\n Usage: 7841_inst.pl num_of_7841 [inst_dir] \n");
   print("        num_of_7841: number of pci7841 cards installed \n");
   print("        inst_dir: installed dir. (not necessary) \n\n");
   exit 0;
}

if(  $ARGV[1] ne "" ){
  if( $ARGV[1] =~ /\/$/){
    ($DRIVER_PATH) = $ARGV[1] =~ /(\S+)\/$/;
  }else{
    $DRIVER_PATH = $ARGV[1];  
  }
}

if( $DRIVER_PATH ne "" ){ 
  $INSMOD_COMMAND = "insmod -f " . $DRIVER_PATH . "/drivers/p7841.ko";
}else{
  $INSMOD_COMMAND = "insmod -f p7841.ko";
}
`$INSMOD_COMMAND`;

#=====================================================================
# extract major number for devices
open (MODULE_LIST, "</proc/devices") || die "can't open /proc/devices";

while (<MODULE_LIST>){
  ($major,$d)=/(\d+)\s(\w+)/;
  next if !$major;
  $MAJOR_NUM{$d}=$major;
}

close MODULE_LIST;

#======================================================================
# remove /dev/device_node and make new node
for( $count=0; $count< $_7841_CARDS; $count++ ){
    my $card_node = "PCI7841" . "W" . $count;
    my $driver_name = "p7841";
      if( $MAJOR_NUM{$driver_name} != "" ){
           if( -e "/dev/$card_node" ){
               unlink "/dev/$card_node";
           }
          `mknod /dev/$card_node c $MAJOR_NUM{$driver_name} $count`;
          print(" make character device node '/dev/$card_node' for PCI7841 \n");
          `chmod a+rw /dev/$card_node`;
      }
}

# copy the libpci_7841.so to /usr/lib
 if( $DRIVER_PATH ne "" ){ 
   $INSMOD_COMMAND ="cp " . $DRIVER_PATH . "/lib/libpci_7841.so /usr/lib";
 }else{
   $INSMOD_COMMAND ="cp ../lib/libpci_7841.so /usr/lib";
 }
 `$INSMOD_COMMAND`;

exit 0;


