#ifndef         _COMMDEF_H_
#define         _COMMDEF_H_

#include <linux/ioctl.h>

/****************************************************************************/
/*      Constant Definitions                                                */
/****************************************************************************/
#define         PCI_7841        0x7841
#define         PCL_CS0         0x00
#define         PCL_CS1         0x80

/****************************************************************************/
/*      Typedef  Definitions                                                */
/****************************************************************************/
#ifndef basic_type
#define basic_type
typedef unsigned char   U8;
typedef short           I16;
typedef unsigned short  U16;
typedef long            I32;
typedef unsigned long   U32;
typedef float           F32;
typedef double          F64;

typedef enum { FALSE, TRUE } BOOLEAN;
#define FIRSTBYTE(VALUE)  (VALUE & 0x00FF)
#define SECONDBYTE(VALUE) ((VALUE >> 8) & 0x00FF)
#define THIRDBYTE(VALUE) ((VALUE >> 8) & 0x00FF)
#define FOURTHBYTE(VALUE) ((VALUE >> 8) & 0x00FF)
#endif // basic_type

typedef struct _tagCAN_PACKET
{
    DWORD CAN_ID;       //  CAN id
    BYTE rtr;           //  RTR bit
    BYTE len;           //  Data length
    BYTE data[8];       //  Data
    DWORD time;         //  Occur time (non use)
    BYTE reserved;      //  future use
}CAN_PACKET;

typedef struct
{
  U16 ret_val;
  int offset;
  BYTE data;
} REG_RW;

typedef struct
{
  DWORD handle;
  DWORD mode;
} RETINFO;

typedef struct
{
  U16 ret_val;
  U16 handle;
  CAN_PACKET msg;
} CAN_MSG;

typedef struct
{
  U16 handle;
  U16 ret_val;
} REC_CN;



#define MAGIC_NUM 'S'

#define IOCTL_7841_SIGNAL1_SET _IO(MAGIC_NUM, 5)
#define IOCTL_7841_SIGNAL2_SET _IO(MAGIC_NUM, 6)
#define IOCTL_7841_SIGNAL3_SET _IO(MAGIC_NUM, 7)
#define IOCTL_7841_SIGNAL4_SET _IO(MAGIC_NUM, 8)
#define IOCTL_7841_SIGNAL5_SET _IO(MAGIC_NUM, 9)
#define IOCTL_7841_SIGNAL6_SET _IO(MAGIC_NUM, 10)
#define IOCTL_7841_SIGNAL7_SET _IO(MAGIC_NUM, 11)
#define IOCTL_7841_SIGNAL8_SET _IO(MAGIC_NUM, 12)
#define IOCTL_7841_CLOSE_PORT _IO(MAGIC_NUM, 13, sizeof(REG_RW))
#define IOCTL_7841_CLOSE_CARD _IO(MAGIC_NUM, 14, sizeof(REG_RW))
#define IOCTL_7841_SET_PORT_MODE _IOW(MAGIC_NUM, 15, sizeof(RETINFO))
#define IOCTL_7841_REG_READ _IOR(MAGIC_NUM, 16, sizeof(REG_RW))
#define IOCTL_7841_REG_WRITE _IOW(MAGIC_NUM, 17, sizeof(REG_RW))
#define IOCTL_7841_SET_BUFFER_DATA _IOW(MAGIC_NUM, 18, sizeof(CAN_MSG))
#define IOCTL_7841_GET_BUFFER_DATA _IOR(MAGIC_NUM, 19, sizeof(CAN_MSG))
#define IOCTL_7841_GET_UNRD_COUNT _IOR(MAGIC_NUM, 20, sizeof(REC_CN))

#define MAX_PCI_CARDS 	4
#define   SIGEVENT1		60
#define   SIGEVENT2		61
#define   SIGEVENT3		62
#define   SIGEVENT4		63
#define   SIGEVENT5		64
#define   SIGEVENT6		65
#define   SIGEVENT7		66
#define   SIGEVENT8		67
#define   SIGEVENT9		68
#define   SIGEVENT10	69
#define   SIGEVENT11	70
#define   SIGEVENT12	71
#define   SIGEVENT13	72
#define   SIGEVENT14	73

#endif








