
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "pci_7841.h"
#include "commdef.h"
#include "conio.h" 

#define  PATTERNS	32

int	rcvPatterns[2];
int handle[2];			//   using for Port Handle
CAN_PACKET rcvMsg0[PATTERNS], rcvMsg1[PATTERNS],sndMsg[PATTERNS];

int main(void)
{
	
	PORT_STRUCT setPort;
	int count, c2, cout1, cout2;    
    	int error_flag=0;

    	if ((handle[0] = CanOpenDriver(0, 0)) == -1)
    	{
        	printf("\nOpen Port 0 Failed!!");
        	return -1;
    	}
  	if ((handle[1] = CanOpenDriver(0, 1)) == -1)
    	{
        	printf("\nOpen Port 1 Failed!!");
        	return -1;
    	}

	CanClearRxBuffer(0);
	CanClearTxBuffer(0);
	CanClearRxBuffer(1);
	CanClearTxBuffer(1);

 	setPort.mode     = 0;       //  0 : 11-bit ;  1 : 29-bit CAN network
	setPort.accCode  = 0;	    //	Only ID = accCode can pass the filter
	setPort.accMask  = 0x7ff;   //  Don't care bit
	setPort.baudrate = 3;       //	0: 125kBps; 1:250kBps;	2:500kBps; 3:1MBps

	CanConfigPort(handle[0], &setPort);
 	CanConfigPort(handle[1], &setPort);
	rcvPatterns[0] = 0;
	rcvPatterns[1] = 0;
	//	Initial send buffer
    	for(count=0;count<PATTERNS;count++)
    	{
      	  sndMsg[count].CAN_ID = count;
      	  sndMsg[count].rtr = 0;
   	  sndMsg[count].len = 8;
      	  for(c2=0;c2<8;c2++)
	  {
		sndMsg[count].data[c2] = c2;
          }
    	}

	printf("Start Transmit %d messages Through PORT1 and PORT2....\n", PATTERNS);
	for(count=0;count<PATTERNS;count++)
	{
		CanSendMsg(handle[0], &sndMsg[count]);
	    	CanSendMsg(handle[1], &sndMsg[count]);
		usleep(1000);
	}

	usleep(5000000);
	cout1 = CanGetRcvCnt(handle[0]);
	cout2 = CanGetRcvCnt(handle[1]);
	printf("Get Receive Message PORT1 %d  PORT2 %d\n", cout1, cout2);

	for(count = 0; count<cout1; count++) 
	{
		    CanRcvMsg(handle[0], &rcvMsg0[rcvPatterns[0]]);
			rcvPatterns[0]++;
	}

	for(count = 0; count<cout2; count++)
	{
		    CanRcvMsg(handle[1], &rcvMsg1[rcvPatterns[1]]);
			rcvPatterns[1]++;
	}


	for(count=0;count<PATTERNS;count++)
	{
		printf("\rexamine %d patterns", count+1);
		if(rcvMsg0[count].CAN_ID != sndMsg[count].CAN_ID)
		{
			error_flag = 1;
			break;
		}
		if(rcvMsg0[count].rtr != sndMsg[count].rtr)
		{
			error_flag = 1;
			break;
		}
		if(rcvMsg0[count].len != sndMsg[count].len)
		{
			error_flag = 1;
			break;
		}
		for(c2=0;c2<8;c2++)
		{
			if(rcvMsg0[count].data[c2] != sndMsg[count].data[c2])
			{

				error_flag = 1;
				break;
			}
		}
		
		if(rcvMsg1[count].CAN_ID != sndMsg[count].CAN_ID)
		{
			error_flag = 1;
			break;
		}
		if(rcvMsg1[count].rtr != sndMsg[count].rtr)
		{
			error_flag = 1;
			break;
		}
		if(rcvMsg1[count].len != sndMsg[count].len)
		{
			error_flag = 1;
			break;
		}
		for(c2=0;c2<8;c2++)
		{
			if(rcvMsg1[count].data[c2] != sndMsg[count].data[c2])
			{
				error_flag = 1;
				break;
			}
		}
	}
	if(error_flag == 1)
		printf("\ntest failed!!\n");
	else
		printf("\ntest ok!!\n");

    	CanCloseDriver(handle[0]);
 	CanCloseDriver(handle[1]);
	printf("Press any key to exit the program...\n");
	return 0;
}


